
########用新的异常数据
########用QREFHT的异常数据代替RH
########
#########CESM


import cdsapi
from netCDF4 import Dataset
import numpy as np
import xarray as xr
import pandas as pd
import math
import glob
import netCDF4 as nc
import matplotlib.pyplot as plt
import cartopy.crs as ccrs
import cartopy.feature as cfeature
from cartopy.mpl.ticker import LongitudeFormatter, LatitudeFormatter
import cmaps
from matplotlib import rcParams
import cartopy.feature as cf
import matplotlib.patches as mpatchesv
import heapq
from matplotlib.ticker import MultipleLocator, FormatStrFormatter
from scipy import interpolate
from scipy.stats import pearsonr
import scipy.stats as stats
from scipy import integrate
import math
import matplotlib.ticker as ticker

def T_test(data_fc,data_md,data3,data4):
    std1=np.zeros((data3.shape[1],data3.shape[2]))
    std2=np.zeros((data4.shape[1],data4.shape[2]))    
    for i in range(data3.shape[1]):
        for j in range(data3.shape[2]):
            std1[i,j]=np.std(data3[:,i,j])
            std2[i,j]=np.std(data4[:,i,j])
    
    z=np.zeros((data_fc.shape[0],data_fc.shape[1]))
    for i in range(data3.shape[1]):
        for j in range(data3.shape[2]):
            data_math1=std1[i,j]**2/(50)
            data_math2=std2[i,j]**2/(20)

            z[i,j]=(data_fc[i,j]-data_md[i,j])/np.sqrt(data_math1+data_math2)
            z1=abs(z)
    
    return z1

#############################################################################################################################空间相关
time_perid='1958_2014'

f1=nc.Dataset('cesm2.FC-MD.ensmean.trend.SST.nc')
dts_slope=f1.variables['sst'][:,:].squeeze()

print('CESM2')

file1='cesm2.FC-MD.ensmean.trend.budget.SST.nc'
f1=nc.Dataset(file1)
lon=f1.variables['lon'][:].squeeze()
lat=f1.variables['lat'][:].squeeze()
Tt1=f1.variables['sst'][:,:].squeeze()
Tt1_area=f1.variables['area'][:,:].squeeze()

f1=nc.Dataset('cesm2.FC-MD.ensmean.trend.budget.SW.nc')
Tsw1=f1.variables['shortwave'][:,:].squeeze()
Tsw1_area=f1.variables['area'][:,:].squeeze()

f1=nc.Dataset('cesm2.FC-MD.ensmean.trend.budget.LW.nc')
Tlw1=f1.variables['longwave'][:,:].squeeze()
Tlw1_area=f1.variables['area'][:,:].squeeze()

f1=nc.Dataset('cesm2.FC-MD.ensmean.trend.budget.SH.nc')
Tsh1=f1.variables['sensible_heat'][:,:].squeeze()
Tsh1_area=f1.variables['area'][:,:].squeeze()

f1=nc.Dataset('cesm2.FC-MD.ensmean.trend.budget.Ocn.nc')
Tocean1=f1.variables['ocean_dynamics_heat'][:,:].squeeze()
Tocean1_area=f1.variables['area'][:,:].squeeze()

f1=nc.Dataset('cesm2.FC-MD.ensmean.trend.budget.LH_W.nc')
Flhw1=f1.variables['latent_heat_wind'][:,:].squeeze()
Flhw1_area=f1.variables['area'][:,:].squeeze()

f1=nc.Dataset('cesm2.FC-MD.ensmean.trend.budget.LH_RH.nc')
Flhrh1=f1.variables['latent_heat_relative_humidity'][:,:].squeeze()
Flhrh1_area=f1.variables['area'][:,:].squeeze()

f1=nc.Dataset('cesm2.FC-MD.ensmean.trend.budget.LH_dT.nc')
Flhdt1=f1.variables['latent_heat_temperature_gradient'][:,:].squeeze()
Flhdt1_area=f1.variables['area'][:,:].squeeze()

name=['${T_S}^t$','${T^t_{SW}}$','${T^t_{LW}}$','${T^t_{SH}}$','${T^t_{Ocn}}$','${T^t_{LH,W}}$','${T^t_{LH,RH}}$','${T^t_{LH,dT}}$']
data=[Tt1,Tsw1,Tlw1,Tsh1,Tocean1,Flhw1,Flhrh1,Flhdt1]
area=[Tt1_area,Tsw1_area,Tlw1_area,Tsh1_area,Tocean1_area,Flhw1_area,Flhrh1_area,Flhdt1_area]

###################################################################################################################################################

w_data=np.zeros((8))
c_data=np.zeros((8))
e_data=np.zeros((8))
data_fc_md=[Tt1,Tsw1,Tlw1,Tsh1,Tocean1,Flhw1,Flhrh1,Flhdt1]
for i in range(8):
    data=data_fc_md[i]
    data1=data[90:102,96:145]
    data1=data1.reshape(-1)
    data1=np.nanmean(data1,axis=0)
    w_data[i]=data1
    
    data2=data[90:102,144:185]####~230
    data2=data2.reshape(-1)
    data2=np.nanmean(data2,axis=0)
    c_data[i]=data2
    
    data3=data[90:102,184:225]
    data3=data3.reshape(-1)
    data3=np.nanmean(data3,axis=0)
    e_data[i]=data3
    
bar_data=[w_data,c_data,e_data]

##############################################################Bar chart of FC-MD

fig = plt.figure(figsize=(16,8),dpi=700)
ax1 = plt.subplot2grid((2,2),(0,0),colspan=2,rowspan=1) # 总共三行三列，ax1从（0,0）处数起占一行三列，其中的数字都是以行列的最小长度为单位
#ax1 =plt.subplot(1,2,2)     #将图片分为2行1列，在第1个区域显示
ax1.spines ['top'] .set_linewidth(1.1)
ax1.spines ['right'] .set_linewidth(1.1)
ax1.spines ['bottom'] .set_linewidth(1.1)
ax1.spines ['left'] .set_linewidth(1.1)
plt.sca(ax1)
colors_group2 = ['#1f77b4','#9467bd', '#d62728']
x=[1,2,3,4,5,6,7,8]
tick_label=['${T^t_{S}}$','${T^t_{SW}}$','${T^t_{LW}}$','${T^t_{SH}}$','${T^t_{Ocn}}$','${T^t_{LH,W}}$','${T^t_{LH,RH}}$','${T^t_{LH,\Delta T}}$']

bar_width=0.16
index1 = np.arange(8) #
index2 = index1 + bar_width # 
index3 = index1 + 2*bar_width # 
#plt.rcParams['font.sans-serif']=['SimHei']############标题可以汉字
#plt.rcParams['axes.unicode_minus'] = False
plt.bar(index1,w_data,width=bar_width,align="center",color='blue',label="Western Pacific",edgecolor='black',\
        linewidth=1.1)
plt.bar(index2,c_data,width=bar_width,align="center",color='orange',label="Central Pacific",edgecolor='black',\
        linewidth=1.1)
plt.bar(index3,e_data,width=bar_width,align="center",color='red',label="Eastern Pacific",edgecolor='black',\
        linewidth=1.1)
plt.legend(frameon=False,fontsize=6,loc="upper right",prop={'family': 'Arial'})

plt.xticks(index2, tick_label,fontsize=26,fontdict={'fontname': 'Arial'})
plt.axhline(0, c='k', linestyle='-',linewidth=0.6,color='k',alpha=0.8)
my_y_ticks = np.arange(-0.1,0.151,0.05)
plt.yticks(my_y_ticks,
     ['-0.1','-0.05','0','0.05','0.1','0.15'],size=20,fontdict={'fontname': 'Arial'})
plt.xlabel("")
plt.ylabel("$^\circ$C/decade",fontsize=22,fontdict={'fontname': 'Arial'})


#plt.legend(loc=‘lower left',bbox_to_anchor=(-0.1, 0),fontsize=20,frameon=False) ##########可以设置位置
plt.grid(linestyle='--',alpha=0.2)   
#plt.axhline(0, c='k', linestyle='-',alpha=0.7)
plt.title('(a) Heat budget analysis for FC-MD SST trend',size=22,fontdict={'fontname': 'Arial'},loc='left',y=1.01)#

rr=['r=0.94','','','','','','','']
##############################################################pattern
name=['(b) '+tick_label[0] ,'(c) '+tick_label[4]]
data=[data_fc_md[0],data_fc_md[4]]
data2=[area[0],area[4]]
#cmap_color=cmaps.BlueDarkRed18
cmap_color=cmaps.BlueDarkRed18
levels1=np.arange(-0.3,0.31,0.03)
levels3=np.arange(-0.1,0.11,0.01)

range_number1=[-0.3,-0.15,0,0.15,0.3]
range_number2=[-0.1,-0.05,0,0.05,0.1]
range_number=[range_number1,range_number1,range_number2]

levell=[levels1,levels1,levels3]

nn=2
range_numberr=range_number[nn]

level_data=levell[nn]

for j in range(2):
    proj=ccrs.PlateCarree(central_longitude=180)  ##设置投影方式,针对坐标轴
    ax1 = plt.subplot2grid((2,2),(1,0+j),colspan=1,rowspan=1,projection=proj)
    region = [120,290,-30,30]  ##设置区域范围

    ax1.spines ['top'] .set_linewidth(1.1)####调整边框粗细
    ax1.spines ['right'] .set_linewidth(1.1)
    ax1.spines ['bottom'] .set_linewidth(1.1)
    ax1.spines ['left'] .set_linewidth(1.1)
    ax1.spines['geo'].set_linewidth(1.1)#调节边框粗细
    plt.sca(ax1)
    
    land = cfeature.NaturalEarthFeature('physical', 'land', scale='50m', facecolor = cfeature.COLORS['land'])
    ax1.add_feature(land, facecolor = 'lightgray',zorder=1) ##这两步是把海岸线中的陆地填上颜色
    ax1.coastlines(linewidth = 1.2)  ##画出海岸线
    ax1.set_extent(region, crs = ccrs.PlateCarree())   ##选择区域
    ###添加经纬度标识,设置大刻度和小刻度
    ax1.set_xticks([120,150, 180, 210, 240,270],crs = ccrs.PlateCarree(),)
    ax1.set_yticks([-30, -15,0,15, 30],crs = ccrs.PlateCarree(),)
    # 利用Formatter格式化刻度标签
    lon_formatter = LongitudeFormatter(zero_direction_label=True)
    lat_formatter = LatitudeFormatter()
    ax1.xaxis.set_major_formatter(lon_formatter)
    ax1.yaxis.set_major_formatter(lat_formatter)

    ax1.xlabel_style = {'font.family':'Arial','size': 40, 'color': 'k'}  #####label字体
    ax1.ylabel_style = {'font.family':'Arial','size': 40, 'color': 'k'}

    ax1.tick_params(direction = 'out',size=8,width=1.2)##刻度长短
    font_title={'family':'Arial',
                'weight':'normal',
                'size':14}
    title = name[j]
    ax1.set_title(title,loc='left',fontdict={'fontname': 'Arial'},fontsize=24,y=1.01)
    
    title1 = rr[j]
    ax1.set_title(title1,loc='right',fontdict={'fontname': 'Arial'},fontsize=20,y=1.01)
    
    levels2=level_data
    cs = ax1.contourf(lon, lat, data[j], levels=levels2,zorder=0,
                     transform=ccrs.PlateCarree(),
                     cmap = cmap_color,
                     extend = 'both') ##超出vmin vmax的都显示出来，否则在图上显示为nan
    sig2 = ax1.contourf(lon, lat,data2[j],colors='none',hatches=['..',None],transform=ccrs.PlateCarree(),zorder=0)
    #ax.gridlines(xlocs=np.arange(0, 20 + 1, 20), ylocs=np.arange(-30, 30 + 1, 30),draw_labels=False, 
    #             x_inline=False, y_inline=False,linewidth=1.4, linestyle='--', color='m')##########赤道上添加直线
    font_title={'family':'Arial',
                'weight':'normal',
                'size':16}

    config = {"font.family":'Arial', "font.size": 17, "mathtext.fontset":'stix'}
    rcParams.update(config)

cax = plt.axes([0.32, 0.065, 0.32, 0.03])  #右 下  长 宽
cbar = fig.colorbar(cs,cax=cax,cmap = cmap_color, extend='both', orientation='horizontal')#
label1='$^\circ$C/decade'
cbar.set_label(label1,font=font_title)
cbar.ax.tick_params(direction = 'out',size=7,labelsize=18)##刻度长短
tick_locator = ticker.MaxNLocator(nbins=5)  # colorbar上的刻度值个数，这个我是参考你之前画的colorbar还原的

cbar.locator = tick_locator
plt.tight_layout()
cbar.set_ticks(range_numberr)

cbar.update_ticks()
fig.subplots_adjust(left=0.099, bottom=0.099, right=0.869, top=0.948, wspace=0.165, hspace=0.227)
#plt.savefig("./fc_md_pic2.png",format='png',dpi=400,bbox_inches='tight')
#plt.savefig("./fc_md_pic2.pdf",format='pdf',dpi=500,bbox_inches='tight')
print('结束')

